%define dist .0.idcf.el6

Summary: Scalr is a pretty darn good open source cloud management tool.
URL:     http://www.scalr.net
Name:    scalr
Version: 4.4.0
Group:   Applications/Internet
Release: 0%{?dist}
License: ASL 2.0
#Source0: https://github.com/Scalr/scalr/archive/4.4.0-RELEASE.tar.gz
Source0: scalr-4.4.0-RELEASE.tar.gz
Source1: scalr-httpd-conf
Source2: cron-scalr-scalr
Source5: README.idcf.scalr
Source6: cron-scalr-root
Source7: scalr.logrotate
Source8: scalr_setup_rpm_v2.sh
Source9: rrdcached.scalr.init
Patch0:  scalr-4.4.0-RELEASE.idcf.patch
#Patch1:  scalr-4.4.0-RELEASE.mindterm.patch
Patch2:  scalr-4.4.0-RELEASE.scalrpy.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: epel-release, idcf-release, remi-release
Requires: php > 5.3.16, php-cli, php-posix, php-pcntl, php-pecl-http1, php-dom
Requires: php-simplexml, php-mysql, php-curl, php-gettext, php-mcrypt
Requires: php-hash, php-json, php-openssl, php-soap
Requires: php-snmp, php-process, php-pecl-ssh2, php-pecl-yaml
Requires: httpd, mod_ssl, mysql-server, bind, net-snmp-utils, rrdtool-php => 1.4.8
Requires: scalr-scalrpy
BuildArch: noarch

%description
Scalr is a pretty darn good open source cloud management tool.
It provides both an automation framework (do Foo when Bar) and
 a web interface (where is this volume mounted) for managing
 infrastructure on the cloud, like EC2.

%package scalrpy
Summary: scalr python module
Requires: scalr, python-pyaml, python-gevent, python-sqlalchemy >= 0.8.2
Requires: python-sqlsoup, python-PyMySQL, python-psutil
Requires: PyYAML, net-snmp-python,rrdtool-python, python-argparse
Requires: m2crypto, swig

%description scalrpy
scalr python module

%prep
%setup -q -n scalr-%{version}-RELEASE

%patch0 -p1
#%%patch1 -p1
%patch2 -p1

%build

cd app/python
CFLAGS="%{optflags}" %{__python} setup.py build

%install
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/scalr

cd app/python
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd ../..
rm -rf app/python

%{__cp} -r app/* ${RPM_BUILD_ROOT}%{_datadir}/scalr
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/www/scalr/cache/smarty_bin/en_US
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/www/scalr/cache/smarty/en_US
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/www/scalr/cache/adodb
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/www/scalr/rrddata
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/www/scalr/graphics
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/log/scalr

echo $RANDOM > ${RPM_BUILD_ROOT}%{_datadir}/scalr/etc/.cryptokey
%{__mv} ${RPM_BUILD_ROOT}%{_datadir}/scalr/etc/config.yml-sample ${RPM_BUILD_ROOT}%{_datadir}/scalr/etc/config.yml

install -p -D -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/scalr.conf

%{__mv} ${RPM_BUILD_ROOT}%{_datadir}/scalr/www/testenvironment.php ./
%{__cp} %{SOURCE2} ./
%{__cp} %{SOURCE5} ./
%{__cp} %{SOURCE6} ./
%{__cp} %{SOURCE8} ./scalr_setup.sh
install -p -D -m 755 %{SOURCE9} $RPM_BUILD_ROOT%{_initrddir}/rrdcached.scalr

%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
%{__cp} %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/scalr

/bin/touch ${RPM_BUILD_ROOT}%{_datadir}/scalr/etc/id
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_var}/named/client_zones
echo '# Zones include file for scalr' > ${RPM_BUILD_ROOT}%{_var}/named/client_zones/zones.include
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/scalr/www/ui2/java

%pre
# Add the "scalr" user
getent group scalr >/dev/null || groupadd -g 200 -r scalr
getent passwd scalr >/dev/null || \
  useradd -r -u 200 -g scalr -G apache -s /sbin/nologin \
    -d /var/www/scalr -c "Scalr" scalr
exit 0

%posttrans
/sbin/service httpd condrestart >/dev/null 2>&1 || :

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root,-)
%doc LICENSE NOTICE README sql/* cron-scalr-scalr cron-scalr-root testenvironment.php README.idcf.scalr scalr_setup.sh
%config(noreplace) %{_sysconfdir}/logrotate.d/scalr
%config(noreplace) %{_sysconfdir}/httpd/conf.d/scalr.conf
%{_initrddir}/rrdcached.scalr
%dir %{_datadir}/scalr
%{_datadir}/scalr/bin
%{_datadir}/scalr/cron
%{_datadir}/scalr/cron-ng
%dir %{_datadir}/scalr/etc
%config(noreplace) %attr(664,scalr,apache) %{_datadir}/scalr/etc/.cryptokey
%{_datadir}/scalr/etc/.htaccess
#%%{_datadir}/scalr/etc/.passwd
#%%{_datadir}/scalr/etc/*_nav*
%config(noreplace) %attr(664,scalr,apache) %{_datadir}/scalr/etc/id
%{_datadir}/scalr/etc/log4php.xml
%config(noreplace) %{_datadir}/scalr/etc/config.yml
%{_datadir}/scalr/etc/version
%{_datadir}/scalr/observers
%dir %{_datadir}/scalr/src
%{_datadir}/scalr/src/Modules
%{_datadir}/scalr/src/Scalr
%{_datadir}/scalr/src/api
%{_datadir}/scalr/src/*.php
%{_datadir}/scalr/src/events
%{_datadir}/scalr/src/externals
%{_datadir}/scalr/src/queue_tasks
%dir %{_datadir}/scalr/src/structs
%config(noreplace) %{_datadir}/scalr/src/structs/struct.CONFIG.php
%{_datadir}/scalr/src/tests
%{_datadir}/scalr/src/types
%{_datadir}/scalr/templates
%{_datadir}/scalr/tests
%{_datadir}/scalr/tools
%{_datadir}/scalr/www
%dir %attr(770,root,named) %{_var}/named/client_zones
%config(noreplace) %attr(640,root,named) %{_var}/named/client_zones/zones.include

%dir %attr(775,scalr,apache) %{_var}/www/scalr
%dir %attr(775,scalr,apache) %{_var}/www/scalr/cache
%dir %attr(775,scalr,apache) %{_var}/www/scalr/cache/smarty_bin
%dir %attr(775,scalr,apache) %{_var}/www/scalr/cache/smarty_bin/en_US
%dir %attr(775,scalr,apache) %{_var}/www/scalr/cache/smarty
%dir %attr(775,scalr,apache) %{_var}/www/scalr/cache/smarty/en_US
%dir %attr(775,scalr,apache) %{_var}/www/scalr/cache/adodb
%dir %attr(775,scalr,apache) %{_var}/www/scalr/rrddata
%dir %attr(775,scalr,apache) %{_var}/www/scalr/graphics
%dir %attr(775,scalr,apache) %{_var}/log/scalr

%files scalrpy
%{python_sitelib}/*

%changelog
* Fri Jul 26 2013 KAJIKAWA Haruhiko <hkajikawa@idcf.jp> - 4.4.0-1
- Version Up

* Wed May 22 2013 KAJIKAWA Haruhiko <hkajikawa@idcf.jp> - 4.1.0-1
- Version Up

* Mon Feb 18 2013 KAJIKAWA Haruhiko <hkajikawa@idcf.jp> - 3.6.0-1
- scalr-3.6.0-idcf.patch update.(add allow-query for dnszone.)

* Thu Dec 13 2012 KAJIKAWA Haruhiko <hkajikawa@idcf.jp> - 3.6.0-0
- first release
